Index: gcc/testsuite/gcc.target/i386/sse-5.c
===================================================================
--- gcc/testsuite/gcc.target/i386/sse-5.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/i386/sse-5.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,6 +1,7 @@
 /* { dg-do compile } */
 /* { dg-require-effective-target ia32 } */
-/* { dg-options "-Winline -Wno-psabi -O2 -mno-sse" } */
+/* { dg-prune-output "ABI for passing parameters" } */
+/* { dg-options "-Winline -O2 -mno-sse" } */
 
 typedef double v2df __attribute__ ((vector_size (16)));
 v2df p;
Index: gcc/testsuite/gcc.target/i386/pr39162.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr39162.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/i386/pr39162.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,11 +1,14 @@
 /* { dg-do compile } */
-/* { dg-options "-O2 -Wno-psabi -msse2 -mno-avx" } */
+/* { dg-prune-output "ABI for passing parameters" } */
+/* { dg-options "-O2 -msse2 -mno-avx" } */
 /* { dg-additional-options "-mabi=sysv" { target x86_64-*-mingw* } } */
 
 typedef long long __m256i __attribute__ ((__vector_size__ (32), __may_alias__));
 
-__m256i
+extern __m256i y;
+
+void
 bar (__m256i x) /* { dg-warning "AVX" "" } */
 {
-  return x;
+  y = x;
 }
Index: gcc/testsuite/gcc.target/i386/pr58137.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr58137.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/i386/pr58137.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,33 @@
+/* { dg-do compile } */
+/* { dg-options "-O3 -mavx2" } */
+
+typedef unsigned int U32;
+
+struct sv {
+  void* sv_any;
+  U32 sv_refcnt;
+  U32 sv_flags;
+};
+typedef struct sv SV;
+
+struct xrv {
+  SV * xrv_rv;
+};
+typedef struct xrv XRV;
+
+extern XRV * PL_xrv_root;
+
+void
+more_xrv (void)
+{
+  register XRV* xrv;
+  register XRV* xrvend;
+  xrv = PL_xrv_root;
+  xrvend = &xrv[200 / sizeof (XRV) - 1];
+  while (xrv < xrvend)
+  {
+    xrv->xrv_rv = (SV*)(xrv + 1);
+    xrv++;
+  }
+  xrv->xrv_rv = 0;
+}
Index: gcc/testsuite/gcc.target/i386/pr59794-4.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr59794-4.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/i386/pr59794-4.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,14 @@
+/* PR target/59794 */
+/* { dg-do compile { target { ia32 } } } */
+/* { dg-options "-O2 -mno-mmx" } */
+/* { dg-skip-if "no MMX vector" { *-*-mingw* } } */
+
+typedef int __v2si __attribute__ ((__vector_size__ (8)));
+
+extern __v2si x;
+
+__v2si
+foo (void)
+{ /* { dg-warning "MMX vector return without MMX enabled changes the ABI" } */
+  return x;
+}
Index: gcc/testsuite/gcc.target/i386/avx-vzeroupper-16.c
===================================================================
--- gcc/testsuite/gcc.target/i386/avx-vzeroupper-16.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/i386/avx-vzeroupper-16.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,5 +1,5 @@
 /* { dg-do compile { target lp64 } } */
-/* { dg-options "-O2 -mavx -mabi=ms -mtune=generic -dp" } */
+/* { dg-options "-O2 -mavx -mabi=ms -maccumulate-outgoing-args -dp" } */
 
 typedef float __m256 __attribute__ ((__vector_size__ (32), __may_alias__));
 
Index: gcc/testsuite/gcc.target/i386/pr30315.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr30315.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/i386/pr30315.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,6 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O2" } */
-/* { dg-final { scan-assembler-times "cmp" 4 } } */
+/* { dg-final { scan-assembler-not "cmp" } } */
 
 extern void abort (void);
 int c;
@@ -34,39 +34,10 @@
 }
 #define PLUSCCONLY(T, t) PLUSCCONLY1(T, t, a) PLUSCCONLY1(T, t, b)
 
-#define MINUSCC(T, t)	\
-T minuscc##t (T a, T b)	\
-{	\
-  T difference = a - b;	\
-  if (difference > a)	\
-    abort ();		\
-  return difference;	\
-}
-
-#define DECCC(T, t)	\
-T deccc##t (T a, T b)	\
-{	\
-  T difference = a - b;	\
-  if (difference > a)	\
-    c --;		\
-  return difference;	\
-}
-
-#define MINUSCCONLY(T, t)	\
-void minuscconly##t (T a, T b)	\
-{	\
-  T difference = a - b;	\
-  if (difference > a)	\
-    abort ();		\
-}
-
 #define TEST(T, t)	\
   PLUSCC(T, t)		\
   PLUSCCONLY(T, t)	\
-  INCCC(T, t)		\
-  MINUSCC(T, t)		\
-  MINUSCCONLY(T, t)	\
-  DECCC(T, t)
+  INCCC(T, t)
 
 TEST (unsigned long,  l)
 TEST (unsigned int,   i)
@@ -84,14 +55,3 @@
 
 PLUSCCZEXT(a)
 PLUSCCZEXT(b)
-
-#define MINUSCCZEXT	\
-unsigned long minuscczext (unsigned int a, unsigned int b)	\
-{	\
-  unsigned int difference = a - b;	\
-  if (difference > a)		\
-    abort ();			\
-  return difference;		\
-}
-
-MINUSCCZEXT
Index: gcc/testsuite/gcc.target/i386/pr43869.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr43869.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/i386/pr43869.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,4 +1,5 @@
 /* { dg-do compile { target lp64 } } */
+/* { dg-options "-maccumulate-outgoing-args" } */
 
 int __attribute__((__noinline__))
 bugged(float f1, float f2, float f3, float f4,
Index: gcc/testsuite/gcc.target/i386/pr43662.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr43662.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/i386/pr43662.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,5 +1,5 @@
 /* { dg-do compile { target lp64 } } */
-/* { dg-options "-O2" } */
+/* { dg-options "-O2 -maccumulate-outgoing-args" } */
 
 void __attribute__ ((ms_abi)) foo (void)
 {
Index: gcc/testsuite/gcc.target/i386/avx-vmovapd-256-1.c
===================================================================
--- gcc/testsuite/gcc.target/i386/avx-vmovapd-256-1.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/i386/avx-vmovapd-256-1.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -15,7 +15,7 @@
 avx_test (void)
 {
   union256d u;
-  double e [4] __attribute__ ((aligned (8)))  = {41124.234,2344.2354,8653.65635,856.43576};
+  double e [4] __attribute__ ((aligned (32)))  = {41124.234,2344.2354,8653.65635,856.43576};
 
   u.x = test (e);
 
Index: gcc/testsuite/gcc.target/i386/nest-1.c
===================================================================
--- gcc/testsuite/gcc.target/i386/nest-1.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/i386/nest-1.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,14 @@
+/* { dg-do compile { target llp64 } } */
+/* { dg-options "" } */
+
+void foo (int i)
+{
+  void nested (void)
+  {
+    char arr[(1U << 31) + 4U];
+    arr[i] = 0;
+  }
+
+  nested ();
+}
+
Index: gcc/testsuite/gcc.target/i386/pr59794-1.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr59794-1.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/i386/pr59794-1.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,15 @@
+/* PR target/59794 */
+/* { dg-do compile { target { ia32 } } } */
+/* { dg-options "-O2 -mno-mmx" } */
+/* { dg-skip-if "no MMX vector" { *-*-mingw* } } */
+
+typedef int __v2si __attribute__ ((__vector_size__ (8)));
+
+extern __v2si x;
+
+extern void bar (__v2si);
+void
+foo (void)
+{
+  bar (x); /* { dg-message "warning: MMX vector argument without MMX enabled changes the ABI" } */
+}
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/pr38891.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/pr38891.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/pr38891.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,7 +1,7 @@
 /* Test for cross x86_64<->w64 abi standard calls.
 */
 /* { dg-do compile } */
-/* { dg-options "-mno-sse" } */
+/* { dg-options "-mno-sse -maccumulate-outgoing-args" } */
 #include "callabi.h"
 
 long double
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-1.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-1.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-1.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -2,7 +2,7 @@
 */
 /* Origin: Kai Tietz <kai.tietz@onevision.com> */
 /* { dg-do run } */
-/* { dg-options "-std=gnu99" } */
+/* { dg-options "-std=gnu99 -maccumulate-outgoing-args" } */
 #include "callabi.h"
 
 extern __SIZE_TYPE__ strlen (const char *);
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-2.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-2.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-2.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -2,7 +2,7 @@
 */
 /* Origin: Kai Tietz <kai.tietz@onevision.com> */
 /* { dg-do run } */
-/* { dg-options "-std=gnu99" } */
+/* { dg-options "-std=gnu99 -maccumulate-outgoing-args" } */
 #include "callabi.h"
 
 extern void abort (void);
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-3.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-3.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-3.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -2,7 +2,7 @@
 */
 /* Origin: Kai Tietz <kai.tietz@onevision.com> */
 /* { dg-do run } */
-/* { dg-options "-std=gnu99" } */
+/* { dg-options "-std=gnu99 -maccumulate-outgoing-args" } */
 #include "callabi.h"
 
 extern void abort (void);
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-4a.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-4a.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-4a.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,6 +1,6 @@
 /* Test for cross x86_64<->w64 abi va_list calls.  */
 /* { dg-do run { target i?86-*-linux* x86_64-*-linux* } } */
-/* { dg-options "-O2 -mabi=ms -std=gnu99 -fno-builtin" } */
+/* { dg-options "-O2 -mabi=ms -std=gnu99 -fno-builtin -maccumulate-outgoing-args" } */
 /* { dg-additional-sources "vaarg-4b.c" } */
 
 extern __SIZE_TYPE__ __attribute__ ((sysv_abi)) strlen (const char *);
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-5a.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-5a.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-5a.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,6 +1,6 @@
 /* Test for cross x86_64<->w64 abi va_list calls.  */
 /* { dg-do run { target i?86-*-linux* x86_64-*-linux* } } */
-/* { dg-options "-O2 -mabi=ms -std=gnu99 -fno-builtin" } */
+/* { dg-options "-O2 -mabi=ms -std=gnu99 -fno-builtin -maccumulate-outgoing-args" } */
 /* { dg-additional-sources "vaarg-5b.c" } */
 
 extern void __attribute__ ((sysv_abi)) abort (void);
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-4b.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-4b.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-4b.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,5 +1,5 @@
 /* Test for cross x86_64<->w64 abi va_list calls.  */
-/* { dg-options "-O2 -mabi=ms -std=gnu99 -fno-builtin" } */
+/* { dg-options "-O2 -mabi=ms -std=gnu99 -fno-builtin -maccumulate-outgoing-args" } */
 
 #include <stdarg.h>
 
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-5b.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-5b.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/vaarg-5b.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,5 +1,5 @@
 /* Test for cross x86_64<->w64 abi va_list calls.  */
-/* { dg-options "-O2 -mabi=ms -std=gnu99 -fno-builtin" } */
+/* { dg-options "-O2 -mabi=ms -std=gnu99 -fno-builtin -maccumulate-outgoing-args" } */
 
 #include <stdarg.h>
 
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/leaf-1.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/leaf-1.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/leaf-1.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,5 +1,5 @@
 /* { dg-do compile } */
-/* { dg-options "-O2 -mabi=sysv" } */
+/* { dg-options "-O2 -mabi=sysv -maccumulate-outgoing-args" } */
 
 __attribute__ ((ms_abi))
 int foo (void)
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/leaf-2.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/leaf-2.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/leaf-2.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,5 +1,5 @@
 /* { dg-do compile } */
-/* { dg-options "-O2 -mabi=sysv" } */
+/* { dg-options "-O2 -mabi=sysv -maccumulate-outgoing-args" } */
 
 extern int glb1, gbl2, gbl3;
 
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/func-1.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/func-1.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/func-1.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -2,7 +2,7 @@
 */
 /* Origin: Kai Tietz <kai.tietz@onevision.com> */
 /* { dg-do run } */
-/* { dg-options "-std=gnu99 -ffast-math" } */
+/* { dg-options "-std=gnu99 -ffast-math -maccumulate-outgoing-args" } */
 #include "callabi.h"
 
 extern void abort (void);
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/func-indirect-2a.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/func-indirect-2a.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/func-indirect-2a.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,6 +1,6 @@
 /* Test for cross x86_64<->w64 abi standard calls via variable.  */
 /* { dg-do run { target i?86-*-linux* x86_64-*-linux* } } */
-/* { dg-options "-O2 -mabi=ms -std=gnu99 -ffast-math -fno-builtin" } */
+/* { dg-options "-O2 -mabi=ms -std=gnu99 -ffast-math -fno-builtin -maccumulate-outgoing-args" } */
 /* { dg-additional-sources "func-indirect-2b.c" } */
 
 extern void __attribute__ ((sysv_abi)) abort (void);
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/func-indirect.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/func-indirect.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/func-indirect.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -2,7 +2,7 @@
 */
 /* Origin: Kai Tietz <kai.tietz@onevision.com> */
 /* { dg-do run } */
-/* { dg-options "-std=gnu99 -ffast-math" } */
+/* { dg-options "-std=gnu99 -ffast-math -maccumulate-outgoing-args" } */
 #include "callabi.h"
 
 extern void abort (void);
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/func-2a.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/func-2a.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/func-2a.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,6 +1,6 @@
 /* Test for cross x86_64<->w64 abi standard calls.  */
 /* { dg-do run { target i?86-*-linux* x86_64-*-linux* } } */
-/* { dg-options "-O2 -mabi=ms -std=gnu99 -ffast-math -fno-builtin" } */
+/* { dg-options "-O2 -mabi=ms -std=gnu99 -ffast-math -fno-builtin -maccumulate-outgoing-args" } */
 /* { dg-additional-sources "func-2b.c" } */
 
 extern void __attribute__ ((sysv_abi)) abort (void);
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/func-indirect-2b.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/func-indirect-2b.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/func-indirect-2b.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,5 +1,5 @@
 /* Test for cross x86_64<->w64 abi standard calls via variable.  */
-/* { dg-options "-O2 -mabi=ms -std=gnu99 -ffast-math -fno-builtin" } */
+/* { dg-options "-O2 -mabi=ms -std=gnu99 -ffast-math -fno-builtin -maccumulate-outgoing-args" } */
 
 typedef int (*func)(void *, char *, char *, short, long long);
 
Index: gcc/testsuite/gcc.target/x86_64/abi/callabi/func-2b.c
===================================================================
--- gcc/testsuite/gcc.target/x86_64/abi/callabi/func-2b.c	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gcc.target/x86_64/abi/callabi/func-2b.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -1,5 +1,5 @@
 /* Test for cross x86_64<->w64 abi standard calls.  */
-/* { dg-options "-mabi=ms -std=gnu99 -ffast-math -fno-builtin" } */
+/* { dg-options "-mabi=ms -std=gnu99 -ffast-math -fno-builtin -maccumulate-outgoing-args" } */
 
 long double func_cross (long double a, double b, float c, long d, int e,
 			char f)
Index: gcc/testsuite/gcc.target/s390/hotpatch-compile-1.c
===================================================================
--- gcc/testsuite/gcc.target/s390/hotpatch-compile-1.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/s390/hotpatch-compile-1.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,27 @@
+/* Functional tests for the function hotpatching feature.  */
+
+/* { dg-do run } */
+/* { dg-options "-O3 -mzarch -mhotpatch" } */
+
+#include <stdio.h>
+
+void hp1(void)
+{
+  printf("hello, world!\n");
+}
+
+inline void hp2(void)
+{
+  printf("hello, world!\n");
+}
+
+__attribute__ ((always_inline))
+void hp3(void) /* { dg-warning "always_inline function might not be inlinable" } */
+{
+  printf("hello, world!\n");
+} /* { dg-warning "function 'hp3' with the 'always_inline' attribute is not hotpatchable" } */
+
+int main (void)
+{
+  return 0;
+}
Index: gcc/testsuite/gcc.target/s390/hotpatch-compile-2.c
===================================================================
--- gcc/testsuite/gcc.target/s390/hotpatch-compile-2.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/s390/hotpatch-compile-2.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,27 @@
+/* Functional tests for the function hotpatching feature.  */
+
+/* { dg-do run } */
+/* { dg-options "-O3 -mzarch -mhotpatch=0" } */
+
+#include <stdio.h>
+
+void hp1(void)
+{
+  printf("hello, world!\n");
+}
+
+inline void hp2(void)
+{
+  printf("hello, world!\n");
+}
+
+__attribute__ ((always_inline))
+void hp3(void) /* { dg-warning "always_inline function might not be inlinable" } */
+{
+  printf("hello, world!\n");
+} /* { dg-warning "function 'hp3' with the 'always_inline' attribute is not hotpatchable" } */
+
+int main (void)
+{
+  return 0;
+}
Index: gcc/testsuite/gcc.target/s390/hotpatch-compile-3.c
===================================================================
--- gcc/testsuite/gcc.target/s390/hotpatch-compile-3.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/s390/hotpatch-compile-3.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,27 @@
+/* Functional tests for the function hotpatching feature.  */
+
+/* { dg-do run } */
+/* { dg-options "-O3 -mzarch -mhotpatch=1" } */
+
+#include <stdio.h>
+
+void hp1(void)
+{
+  printf("hello, world!\n");
+}
+
+inline void hp2(void)
+{
+  printf("hello, world!\n");
+}
+
+__attribute__ ((always_inline))
+void hp3(void) /* { dg-warning "always_inline function might not be inlinable" } */
+{
+  printf("hello, world!\n");
+} /* { dg-warning "function 'hp3' with the 'always_inline' attribute is not hotpatchable" } */
+
+int main (void)
+{
+  return 0;
+}
Index: gcc/testsuite/gcc.target/s390/hotpatch-compile-4.c
===================================================================
--- gcc/testsuite/gcc.target/s390/hotpatch-compile-4.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/s390/hotpatch-compile-4.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,11 @@
+/* Functional tests for the function hotpatching feature.  */
+
+/* { dg-do compile } */
+/* { dg-options "-O3 -mzarch -mhotpatch=-1" } */
+
+int main (void)
+{
+  return 0;
+}
+
+/* { dg-excess-errors "argument to '-mhotpatch=' should be a non-negative integer" } */
Index: gcc/testsuite/gcc.target/s390/hotpatch-compile-5.c
===================================================================
--- gcc/testsuite/gcc.target/s390/hotpatch-compile-5.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/s390/hotpatch-compile-5.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,28 @@
+/* Functional tests for the function hotpatching feature.  */
+
+/* { dg-do compile } */
+/* { dg-options "-O3 -mzarch -mhotpatch=1000000" } */
+
+#include <stdio.h>
+
+void hp1(void)
+{
+  printf("hello, world!\n");
+}
+
+__attribute__ ((hotpatch(1000000)))
+void hp2(void)
+{
+  printf("hello, world!\n");
+}
+
+__attribute__ ((hotpatch(1000001)))
+void hp3(void)
+{ /* { dg-error "requested 'hotpatch' attribute is not a non-negative integer constant or too large .max. 1000000." } */
+  printf("hello, world!\n");
+}
+
+int main (void)
+{
+  return 0;
+}
Index: gcc/testsuite/gcc.target/s390/hotpatch-compile-6.c
===================================================================
--- gcc/testsuite/gcc.target/s390/hotpatch-compile-6.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/s390/hotpatch-compile-6.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,11 @@
+/* Functional tests for the function hotpatching feature.  */
+
+/* { dg-do compile } */
+/* { dg-options "-O3 -mzarch -mhotpatch=1000001" } */
+
+int main (void)
+{
+  return 0;
+}
+
+/* { dg-excess-errors "argument to '-mhotpatch=' is too large .max. 1000000." } */
Index: gcc/testsuite/gcc.target/s390/htm-builtins-compile-1.c
===================================================================
--- gcc/testsuite/gcc.target/s390/htm-builtins-compile-1.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/s390/htm-builtins-compile-1.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,165 @@
+/* This checks the availability of the low-level builtins introduced
+   for transactional execution.  */
+
+/* { dg-do compile } */
+/* { dg-require-effective-target htm } */
+/* { dg-options "-O3 -march=zEC12 -mzarch" } */
+
+#include <stdint.h>
+#include <htmintrin.h>
+
+int global = 0;
+uint64_t g;
+struct __htm_tdb global_tdb;
+
+int
+foo (struct __htm_tdb* tdb, int reg, int *mem, uint64_t *mem64)
+{
+
+  int cc;
+  int n;
+
+  __builtin_tbegin ((void *)0);
+  __builtin_tbegin ((void *)-99999);
+  __builtin_tbegin ((void *)99999);
+  while (__builtin_tbegin ((void *)0) != 0)
+  {
+  }
+  cc = __builtin_tbegin ((void *)0x12345678);
+  cc = __builtin_tbegin (tdb);
+  cc = __builtin_tbegin (&global_tdb);
+  cc = __builtin_tbegin ((void *)(long long)(reg + 0x12345678));
+  cc = __builtin_tbegin ((void *)(long long)(reg));
+
+  __builtin_tbegin_nofloat ((void *)0);
+  __builtin_tbegin_nofloat ((void *)-99999);
+  __builtin_tbegin_nofloat ((void *)99999);
+  cc = __builtin_tbegin_nofloat ((void *)0x12345678);
+  cc = __builtin_tbegin_nofloat (tdb);
+  cc = __builtin_tbegin_nofloat (&global_tdb);
+  cc = __builtin_tbegin_nofloat ((void *)(long long)(reg + 0x12345678));
+  cc = __builtin_tbegin_nofloat ((void *)(long long)(reg));
+
+  __builtin_tbegin_retry ((void *)0, 0);
+  cc = __builtin_tbegin_retry ((void *)0, 1);
+  cc = __builtin_tbegin_retry ((void *)0, -1);
+  cc = __builtin_tbegin_retry ((void *)0, 42);
+  cc = __builtin_tbegin_retry ((void *)0, reg);
+  cc = __builtin_tbegin_retry ((void *)0, *mem);
+  cc = __builtin_tbegin_retry ((void *)0, global);
+  cc = __builtin_tbegin_retry (tdb, 42);
+  cc = __builtin_tbegin_retry (&global_tdb, 42);
+  cc = __builtin_tbegin_retry ((void *)0x12345678, global);
+  cc = __builtin_tbegin_retry (
+	  (void *)(long long) (reg + 0x12345678), global + 1);
+  cc = __builtin_tbegin_retry (
+	  (void *)(long long)(reg), global - 1);
+
+  __builtin_tbegin_retry_nofloat ((void *)0, 0);
+  cc = __builtin_tbegin_retry_nofloat ((void *)0, 1);
+  cc = __builtin_tbegin_retry_nofloat ((void *)0, -1);
+  cc = __builtin_tbegin_retry_nofloat ((void *)0, 42);
+  cc = __builtin_tbegin_retry_nofloat ((void *)0, reg);
+  cc = __builtin_tbegin_retry_nofloat ((void *)0, *mem);
+  cc = __builtin_tbegin_retry_nofloat ((void *)0, global);
+  cc = __builtin_tbegin_retry_nofloat (tdb, 42);
+  cc = __builtin_tbegin_retry_nofloat (&global_tdb, 42);
+  cc = __builtin_tbegin_retry_nofloat ((void *)0x12345678, global);
+  cc = __builtin_tbegin_retry_nofloat (
+	  (void *)(long long) (reg + 0x12345678), global + 1);
+  cc = __builtin_tbegin_retry_nofloat (
+	  (void *)(long long)(reg), global - 1);
+
+  __builtin_tbeginc ();
+
+  __builtin_tx_nesting_depth ();
+  n = __builtin_tx_nesting_depth ();
+
+  __builtin_non_tx_store (mem64, 0);
+  {
+	  const uint64_t val_var = 0x1122334455667788;
+
+	  __builtin_non_tx_store (mem64, val_var);
+  }
+  __builtin_non_tx_store (mem64, (uint64_t)reg);
+  __builtin_non_tx_store (mem64, g);
+  __builtin_non_tx_store ((uint64_t *)0, 0);
+  __builtin_non_tx_store ((uint64_t *)0x12345678, 0);
+  __builtin_non_tx_store (&g, 23);
+  __builtin_non_tx_store (&g, reg);
+  __builtin_non_tx_store (&g, *mem);
+  __builtin_non_tx_store (&g, global);
+
+  __builtin_tend();
+
+  __builtin_tx_assist (0);
+  __builtin_tx_assist (1);
+  __builtin_tx_assist (reg);
+  __builtin_tx_assist (*mem);
+  __builtin_tx_assist (global);
+}
+
+/* The taborts must go into separate function since they are
+   "noreturn".  */
+
+void
+tabort1 ()
+{
+  __builtin_tabort (256);
+}
+
+void
+tabort2 (int reg)
+{
+  __builtin_tabort (reg);
+}
+
+void
+tabort3 (int reg)
+{
+  /* { dg-final { scan-assembler-times "tabort\t255" 1 } } */
+  __builtin_tabort (reg + 255);
+}
+
+void
+tabort4 (int *mem)
+{
+  __builtin_tabort (*mem);
+}
+
+void
+tabort5 ()
+{
+  __builtin_tabort (global);
+}
+
+void
+tabort6 (int *mem)
+{
+  /* Here global + 255 gets reloaded into a reg.  Better would be to
+     just reload global or *mem and get the +255 for free as address
+     arithmetic.  */
+  __builtin_tabort (*mem + 255);
+}
+
+void
+tabort7 ()
+{
+  __builtin_tabort (global + 255);
+}
+
+void
+tabort8 ()
+{
+  __builtin_tabort (-1);
+}
+
+
+/* Make sure the tdb NULL argument ends up as immediate value in the
+   instruction.  */
+/* { dg-final { scan-assembler-times "tbegin\t0," 17 } } */
+/* { dg-final { scan-assembler-times "tbegin\t" 41 } } */
+/* Check number of occurences of certain instructions.  */
+/* { dg-final { scan-assembler-times "tbeginc\t" 1 } } */
+/* { dg-final { scan-assembler-times "tabort\t" 8 } } */
+/* { dg-final { scan-assembler "ppa\t" } } */
Index: gcc/testsuite/gcc.target/s390/hotpatch-compile-7.c
===================================================================
--- gcc/testsuite/gcc.target/s390/hotpatch-compile-7.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/s390/hotpatch-compile-7.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,68 @@
+/* Functional tests for the function hotpatching feature.  */
+
+/* { dg-do run } */
+/* { dg-options "-O3 -mzarch -mno-hotpatch" } */
+
+#include <stdio.h>
+
+__attribute__ ((hotpatch))
+void hp1(void)
+{
+  printf("hello, world!\n");
+}
+
+__attribute__ ((hotpatch))
+inline void hp2(void)
+{
+  printf("hello, world!\n");
+}
+
+__attribute__ ((hotpatch))
+__attribute__ ((always_inline))
+void hp3(void) /* { dg-warning "always_inline function might not be inlinable" } */
+{
+  printf("hello, world!\n");
+} /* { dg-warning "function 'hp3' with the 'always_inline' attribute is not hotpatchable" } */
+
+__attribute__ ((hotpatch(0)))
+void hp4(void)
+{
+  printf("hello, world!\n");
+}
+
+__attribute__ ((hotpatch(0)))
+inline void hp5(void)
+{
+  printf("hello, world!\n");
+}
+
+__attribute__ ((hotpatch(0)))
+__attribute__ ((always_inline))
+void hp6(void) /* { dg-warning "always_inline function might not be inlinable" } */
+{
+  printf("hello, world!\n");
+} /* { dg-warning "function 'hp6' with the 'always_inline' attribute is not hotpatchable" } */
+
+__attribute__ ((hotpatch(1)))
+void hp7(void)
+{
+  printf("hello, world!\n");
+}
+
+__attribute__ ((hotpatch(1)))
+inline void hp8(void)
+{
+  printf("hello, world!\n");
+}
+
+__attribute__ ((hotpatch(1)))
+__attribute__ ((always_inline))
+void hp9(void) /* { dg-warning "always_inline function might not be inlinable" } */
+{
+  printf("hello, world!\n");
+} /* { dg-warning "function 'hp9' with the 'always_inline' attribute is not hotpatchable" } */
+
+int main (void)
+{
+  return 0;
+}
Index: gcc/testsuite/gcc.target/s390/htm-builtins-compile-2.c
===================================================================
--- gcc/testsuite/gcc.target/s390/htm-builtins-compile-2.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/s390/htm-builtins-compile-2.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,13 @@
+/* { dg-do compile } */
+/* { dg-require-effective-target htm } */
+/* { dg-options "-O3 -march=zEC12 -mzarch" } */
+
+void must_not_compile1 (void)
+{
+  __builtin_tabort (0); /* { dg-error "Invalid transaction abort code:" } */
+}
+
+void must_not_compile2 (void)
+{
+  __builtin_tabort (255); /* { dg-error "Invalid transaction abort code:" } */
+}
Index: gcc/testsuite/gcc.target/s390/hotpatch-compile-8.c
===================================================================
--- gcc/testsuite/gcc.target/s390/hotpatch-compile-8.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/s390/hotpatch-compile-8.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,23 @@
+/* Functional tests for the function hotpatching feature.  */
+
+/* { dg-do run } */
+/* { dg-options "-O3 -mzarch -mhotpatch" } */
+
+#include <stdio.h>
+
+int hp1(void)
+{
+  int nested1(void) /* { dg-warning "hotpatching is not compatible with nested functions" } */
+  { return 1; }
+
+  __attribute__ ((hotpatch))
+  int nested2(void) /* { dg-warning "hotpatching is not compatible with nested functions" } */
+  { return 1; }
+
+  return nested1() - nested2();
+}
+
+int main (void)
+{
+  return hp1();
+}
